using System;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace ReleaseMe
{
	public class ReleaseMe : HBPlugin
	{
		#region Creator info

		public override string Author { get { return "namednoob"; } }
		public override Version Version { get { return new Version(0, 0, 1); } }
		public override string Name { get { return "ReleaseMe"; } }
		public override string ButtonText { get { return "Settings"; } }
		public override bool WantButton { get { return false; } }

		#endregion

		#region Main code

		public static LocalPlayer Me { get { return StyxWoW.Me; } }
		private bool _release = false;

		public ReleaseMe()
		{
		}

		public override void Pulse()
		{
			if (!StyxWoW.IsInGame)
			{
				return;
			}

			if (_release && Me.IsDead && !Me.IsGhost)
			{
				Log(Name, "We are dead and not yet a ghost, releasing...");
				Lua.DoString("RepopMe();");
				_release = false;
			}
		}

		private void SetRelease(object sender, LuaEventArgs args)
		{
			Log(Name, "Death event trigged...");
			_release = true;
		}

		public override void OnEnable()
		{
			base.OnEnable();
			Lua.Events.AttachEvent("PLAYER_DEAD", SetRelease);
			Log(Name, "Enabled v{0}", Version);
		}

		public override void OnDisable()
		{
			Lua.Events.DetachEvent("PLAYER_DEAD", SetRelease);
			Log(Name, "Disabled v{0}", Version);
			base.OnDisable();
		}

		#endregion

		public static void Log(string Name, string format, params object[] args)
		{
			Logging.Write(Colors.Orange, "[" + Name + "] " + format, args);
		}
	}
}